\documentclass{article}

\RequirePackage[utf8]{inputenc}
\usepackage[russian]{babel}
\usepackage{hyperref}
\usepackage{graphicx, float, caption}
\usepackage[a4paper, margin={3cm, 3cm}]{geometry}
\usepackage{listings}
\usepackage{listingsutf8}
\usepackage{color}
\usepackage{multirow}
\usepackage{threeparttablex, caption}
\usepackage{pdfpages}
\usepackage{pgfplots}

\definecolor{mGreen}{rgb}{0,0.6,0}
\definecolor{mGray}{rgb}{0.5,0.5,0.5}
\definecolor{mPurple}{rgb}{0.58,0,0.82}
\definecolor{codeBackgroundColour}{rgb}{0.95,0.95,0.92}
\definecolor{shellBackgroundColour}{rgb}{0.90,0.90,1.00}
\lstset{
	inputencoding=utf8,
	literate={∫}{{$\int$}}1
}
\lstdefinestyle{CStyle}{
    commentstyle=\color{mGreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{mGray},
    stringstyle=\color{mPurple},
    basicstyle=\ttfamily\footnotesize, breakatwhitespace=false,
    breaklines=true,
    captionpos=t,
    keepspaces=true,
    numbers=left,
    numbersep=5pt,
    showspaces=false,
    showstringspaces=false,
    showtabs=false,
    tabsize=2,
    language=C
}
\lstdefinestyle{ShellStyle}{
    backgroundcolor=\color{shellBackgroundColour},
    commentstyle=\color{mGreen},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,
    captionpos=t,
    keepspaces=true,
    showspaces=false,
    showstringspaces=false,
    showtabs=false,
    tabsize=2,
    framexleftmargin=5pt,
    frame=shadowbox
}
\pgfplotsset{
	small,
}

\title{Лабораторная работа №4}
\author{Януш Герман}

\begin{document}
\maketitle

\begin{table}[ht]
	\centering
	\resizebox{\textwidth}{!}{\begin{tabular}{|p{2cm}|p{2cm}|p{3cm}|p{1.5cm}|p{1.5cm}|p{1.5cm}|p{1.5cm}|p{1.5cm}|p{1.5cm}|}
\hline
	\multirow{2}{5cm}{N} & \multirow{2}{5cm}{Функция} & Последовательная программа & \multicolumn{3}{c|}{2 потока} & \multicolumn{3}{c|}{4 потока}\\
	\cline{3-9}
	& & Время & Время & Ускорение & Эффек--тивность & Время & Ускорение & Эффек--тивность\\\hline
	1000 & $\sin(x)$ & 68мкс & 135мкс & 0.501 & 0.251 & 127мкс & 0.534 & 0.134\\
	1000 & $\exp(x)$ & 54мкс & 129мкс & 0.419 & 0.210 & 101мкс & 0.535 & 0.134\\
	1000 & $x^2$ & 46мкс & 132мкс & 0.351 & 0.176 & 230мкс & 0.202 & 0.051\\\hline
	1000,000 & $\sin(x)$ & 49мс & 22мс & 2.207 & 1.104 & 14мс & 3.485 & 0.874\\
	1000,000 & $\exp(x)$ & 39мс & 20мс & 1.925 & 0.963 & 12мс & 3.080 & 0.770\\
	1000,000 & $x^2$ & 34мс & 17мс & 1.941 & 0.971 & 12мс & 2.811 & 0.703\\\hline
	1000,000,000 & $\sin(x)$ & 41с353мс & 21с131мс & 1.957 & 0.979 & 13с068мс & 3.164 & 0.791\\
	1000,000,000 & $\exp(x)$ & 37с959мс & 19с030мс & 1.995 & 0.998 & 11с970мс & 3.171 & 0.793\\
	1000,000,000 & $x^2$ & 32с864мс & 16с700мс & 1.968 & 0.985 & 10с439мс & 3.148 & 0.787\\
\hline
\end{tabular}}
\caption{Время работы программ в секундах, на разных функциях с разными N}
\end{table}

\begin{figure}[h!]
\begin{minipage}{.5\textwidth}
\begin{tikzpicture}
\centering
	\begin{axis}[
	xtick={1000,1000000,1000000000},
	xlabel=Количество элементов,
	ylabel=Ускорение,
	legend style={
			legend cell align=left,
	},
	legend pos=south east,
	xmode=log,
	log ticks with fixed point
	]
		\addplot coordinates {
			(1000,  0.501)
			(1000000, 2.207)
			(1000000000, 1.957)
		};
	\addlegendentry{$\sin(x)$}
		\addplot coordinates {
			(1000, 0.419)
			(1000000, 1.925)
			(1000000000, 1.995)
		};
	\addlegendentry{$\exp(x)$}
		\addplot coordinates {
			(1000, 0.351)
			(1000000, 1.941)
			(1000000000, 1.968)
		};
	\addlegendentry{$x^2$}
	\end{axis}
\end{tikzpicture}
\caption{Ускорение (2 потока)}
\end{minipage}
\begin{minipage}{.5\textwidth}
\begin{tikzpicture}
\centering
	\begin{axis}[
	xtick={1000,1000000,1000000000},
	xlabel=Количество элементов,
	ylabel=Ускорение,
	legend style={
			legend cell align=left,
	},
	legend pos=south east,
	xmode=log,
	log ticks with fixed point
	]
	\addplot coordinates {
			(1000,  0.534)
			(1000000, 3.485)
			(1000000000, 3.164)
		};
	\addlegendentry{$\sin(x)$}
	\addplot coordinates {
			(1000, 0.535)
			(1000000, 3.080)
			(1000000000, 3.171)
		};
	\addlegendentry{$\exp(x)$}
	\addplot coordinates {
			(1000, 0.202)
			(1000000, 2.811)
			(1000000000, 3.148)
		};
	\addlegendentry{$x^2$}
	\end{axis}
\end{tikzpicture}
\caption{Ускорение (4 потока)}
\end{minipage}
\end{figure}

\begin{figure}[h!]
\begin{minipage}{.5\textwidth}
\begin{tikzpicture}
\centering
	\begin{axis}[
	xtick={1000,1000000,1000000000},
	xlabel=Количество элементов,
	ylabel=Эффективность,
	legend style={
			legend cell align=left,
	},
	legend pos=south east,
	xmode=log,
	log ticks with fixed point
	]
		\addplot coordinates {
			(1000,  0.251)
			(1000000, 1.104)
			(1000000000, 0.979)
		};
	\addlegendentry{$\sin(x)$}
		\addplot coordinates {
			(1000, 0.210)
			(1000000, 0.963)
			(1000000000, 0.998)
		};
	\addlegendentry{$\exp(x)$}
		\addplot coordinates {
			(1000, 0.176)
			(1000000, 0.971)
			(1000000000, 0.985)
		};
	\addlegendentry{$x^2$}
	\end{axis}
\end{tikzpicture}
\caption{Эффективность (2 потока)}
\end{minipage}
\begin{minipage}{.5\textwidth}
\begin{tikzpicture}
\centering
	\begin{axis}[
	xtick={1000,1000000,1000000000},
	xlabel=Количество элементов,
	ylabel=Эффективность,
	legend style={
			legend cell align=left,
	},
	legend pos=south east,
	xmode=log,
	log ticks with fixed point
	]
	\addplot coordinates {
			(1000,  0.134)
			(1000000, 0.874)
			(1000000000, 0.791)
		};
	\addlegendentry{$\sin(x)$}
	\addplot coordinates {
			(1000, 0.134)
			(1000000, 0.770)
			(1000000000, 0.793)
		};
	\addlegendentry{$\exp(x)$}
	\addplot coordinates {
			(1000, 0.051)
			(1000000, 0.703)
			(1000000000, 0.787)
		};
	\addlegendentry{$x^2$}
	\end{axis}
\end{tikzpicture}
\caption{Эффективность (4 потока)}
\end{minipage}
\end{figure}


\lstinputlisting[style=CStyle]{integral.cpp}
\end{document}

